<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <meta http-equiv="X-UA-Compatible" content="IE=edge" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <script src="{{ url_for('static' , filename = '/js/jquery-3.6.0.min.js')}}"></script>
    <script src="{{ url_for('static' , filename = '/js/jquery.cookie.js')}}"></script>
    <title>Flask - Cookies</title>
  </head>
  <body>
    <h1>Flask - Cookies</h1>

    <h3>Example :</h3>
    <ul>
      <li>1. account : DevAuth</li>
      <li>2. isRememberMe : true</li>
      <li>3. shoppingCart : 1,2,3,4,5</li>
      <li>4. buyNextTime : 6,7,8,9,10</li>
      <li>5. queryRecord : Cookie,Session</li>
    </ul>

    <h3>Table</h3>
    <table border="1">
      <thead>
        <tr>
          <th>&nbsp;&nbsp;id&nbsp;&nbsp;</th>
          <th>&nbsp;name&nbsp;</th>
          <th>&nbsp;&nbsp;id&nbsp;&nbsp;</th>
          <th>&nbsp;name&nbsp;</th>
        </tr>
      </thead>
      <tbody>
        <tr>
          <td>&nbsp;1</td>
          <td>&nbsp;PythonSE&nbsp;</td>
          <td>&nbsp;6</td>
          <td>&nbsp;HtmlSE&nbsp;</td>
        </tr>
        <tr>
          <td>&nbsp;2</td>
          <td>&nbsp;PythonDoc&nbsp;</td>
          <td>&nbsp;7</td>
          <td>&nbsp;jQuerySE&nbsp;</td>
        </tr>
        <tr>
          <td>&nbsp;3</td>
          <td>&nbsp;FlaskSE&nbsp;</td>
          <td>&nbsp;8</td>
          <td>&nbsp;CSS-Style&nbsp;</td>
        </tr>
        <tr>
          <td>&nbsp;4</td>
          <td>&nbsp;PythonSQL&nbsp;</td>
          <td>&nbsp;9</td>
          <td>&nbsp;JavaSE&nbsp;</td>
        </tr>
        <tr>
          <td>&nbsp;5</td>
          <td>&nbsp;PythonOCR&nbsp;</td>
          <td>&nbsp;10</td>
          <td>&nbsp;SQL-SE&nbsp;</td>
        </tr>
      </tbody>
    </table>

    <p>key : <input type="text" id="edtKey" /></p>
    <p>value : <input type="text" id="edtValue" /></p>
    <button id="btnSave">Save</button>
    <button id="btnRead">Read</button>
    <button id="btnDelete">Delete</button>
    <hr />
    <h3>Result :</h3>
    <div id="console"></div>
    <hr />
    <h3>Data :</h3>
    <div id="data"></div>
    <hr />
    <h3>Login :</h3>
    <form action="/login" method="POST">
      帳號 : <input id="edtAc" type="text" name="account" />
      <input id="chkRememberMe" type="checkbox" name="isRememberMe" value="true"/>記住我<br />
      密碼 : <input id="edtPw" type="password" name="password"/>
      <button type="submit" id="btnLogin">Login</button>
    </form>
    <script>
      $(function () {
        var $edtKey = $("#edtKey");
        var $edtValue = $("#edtValue");

        var $btnSave = $("#btnSave");
        var $btnRead = $("#btnRead");
        var $btnDelete = $("#btnDelete");

        var $console = $("#console");
        var $data = $("#data");

        var $edtAccount = $("#edtAc");
        var $edtPassword = $("#edtPw");
        var $chkRememberMe = $("#chkRememberMe");
        // var $btnLogin = $("#btnLogin");

        var lstData = [];

        $btnSave.off("click").on("click", function () {
          var key = $edtKey.val();
          var val = $edtValue.val();

          // $.cookie(key , val);
          $.cookie(key, val, { expires: 1, path: "/" });

          $edtKey.val("");
          $edtValue.val("");
          $console.text("OK");
          showCookie();
          showLoginInfo();
        });

        $btnRead.off("click").on("click", function () {
          var key = $edtKey.val();
          var val = $.cookie(key);

          $edtKey.val("");
          $edtValue.val("");
          $console.text("key = " + key + " , value = " + val);

          showCookie();
          showLoginInfo();
        });

        $btnDelete.off("click").on("click", function () {
          let key = $edtKey.val();
          // let val = $.removeCookie(key);
          let val = $.removeCookie(key, { path: "/" });
          if (!val) {
            alert("Delete Fail !");
          }

          $edtKey.val("");
          $edtValue.val("");
          $console.text("OK");

          showCookie();
          showLoginInfo();
        });

        // $btnLogin.off("click").on("click", function () {
        //   let account = $edtAccount.val();
        //   let isRememberMe = $chkRememberMe.prop("checked");

        //   if (isRememberMe) {
        //     $.cookie("account", account, { expires: 1, path: "/" });
        //     $.cookie("isRememberMe", isRememberMe, { expires: 1, path: "/" });
        //     showCookie();
        //     showLoginInfo();
        //   } else {
        //     // $.removeCookie("account");
        //     // $.removeCookie("isRememberMe");
        //     $.removeCookie("account", { path: "/" });
        //     $.removeCookie("isRememberMe", { path: "/" });

        //     showCookie();
        //     showLoginInfo();
        //   }

        //   alert("OK");
        // });

        function showCookie() {
          $data.html("");
          lstData = [];
          var cookie = $.cookie();
          var i = 0;
          $.each(cookie, function (key, val) {
            var btnSelect =
              "<button name='btnSelect' value=" + i + ">Select</butotn>";
            lstData.push({ key: key, val: val });
            $data.append(btnSelect);
            $data.append(" ");
            $data.append(key);
            $data.append("=");
            $data.append(val);
            $data.append("<br>");
            i++;
          });

          for (var i = 0; i < cookie.length; i++) {
            var data = cookie[i];
            if (data.indexOf("=") != -1) {
              var arr = data.split("=");
            }
          }

          var $btnSelect = $("[name=btnSelect]");
          $btnSelect.off("click").on("click", function () {
            let idx = $(this).val();
            $edtKey.val(lstData[idx].key);
          });
        }

        function showLoginInfo() {
          let account = $.cookie("account");
          let isRememberMe = $.cookie("isRememberMe") == "true";

          if (isRememberMe) {
            $edtAccount.val(account);
          } else {
            $edtAccount.val("");
          }

          $chkRememberMe.prop("checked", isRememberMe);
          $edtPassword.val("");
        }

        showLoginInfo();
        showCookie();
      });
    </script>
  </body>
</html>
